// TBRCMD.CH - TBrowse Command Set

#include "basic.ch"

#command DEFINE [DATABASE] RANGE BROWSE <(tb)>;
                [RANGE VALUES <values,...>];
                [RANGE KEY <key>];
                [FROM <t>,<l>] [TO <b>,<r>];
                [<dc: DEFAULT COLUMNS>];
                [BOX <bdr>] [<dbl: DOUBLE>];
                [ELSE <else>];
=>;
         BrowseAdd( TBrowseRange( <(tb)>,<t>,<l>,<b>,<r>,;
                      {<values>},<{key}>,<.dc.>,;
                      IIf( <.bdr.>,<bdr>,IIf(<.dbl.>,2,1) ),<{else}> ) )

#command SET [BROWSE] RANGE VALUES [OF <(tb)>] TO <value,...>;
=>;
         BrowseValues( <(tb)>, {<value>} )

#command SET [BROWSE] RANGE KEY [OF <(tb)>] TO <key>;
=>;
         BrowseKeyExpr( <(tb)>, <{key}> )


#command DEFINE DATABASE BROWSE <(tb)> [FROM <t>,<l>] [TO <b>,<r>];
                                     [<dc: DEFAULT COLUMNS>];
                                     [BOX <bdr>] [<dbl: DOUBLE>];
                                     [ELSE <else>];
=>;
         BrowseAdd( TBrowseDatabase( <(tb)>,<t>,<l>,<b>,<r>,<.dc.>,;
                     IIf( <.bdr.>,<bdr>, IIf(<.dbl.>,2,1)),<{else}> ) )


#command DEFINE ARRAY BROWSE <(tb)> [ON [ARRAY] <a>];
                                  [FROM <t>,<l>];
                                  [TO <b>,<r>];
                                  [ROW POINTER <i>];
                                  [BOX <bdr>] [<dbl: DOUBLE>];
                                  [ELSE <else>];
=>;
         BrowseAdd( TBrowseArray( <(tb)>,<t>,<l>,<b>,<r>,<a>,;
                     {|x| IIf( x==NIL,<i>,<i>:=x ) },;
                     IIf( <.bdr.>,<bdr>, IIf(<.dbl.>,2,1)),<{else}> ) )


#command SET BROWSE KEY <n> [OF <(tb)>] TO <proc> [USING <vars,...>];
=>;
         BrowseSetKey( <(tb)>, <n>, {|b| <proc>( b,<vars> ) } )


#command SET BROWSE KEY <n> [OF <(tb)>] TO;
=>;
         BrowseSetKey( <(tb)>, <n>, NIL )


#command SELECT BROWSE <(tb)>;
=>;
         BrowseSelect( <(tb)> )


#command ACTIVATE BROWSE [<(tb)>];
=>;
         BrowseActivate( <(tb)> )


#command RELEASE BROWSE [<(tb)>];
=>;
         BrowseRelease( <(tb)> )



#command ADD BROWSE COLUMN <(c)> [HEADING <head>] [CONTENTS <expr>] [TO <(tb)>];
=>;
         ColumnAdd( TBColumnDefine( <(c)>,<{expr}>,<head> ),<(tb)> )


#command DELETE BROWSE COLUMN <(c)> [OF <(tb)>];
=>;
         ColumnDel( <(c)>,<(tb)> )


#command INSERT BROWSE COLUMN <(c)> [HEADING <head>] [CONTENTS <expr>];
                                  [INTO <(tb)>] [AT [POSITION] <n>];
=>;
         ColumnIns( TBColumnDefine( <(c)>,<{expr}>,<head> ),<n>,<(tb)> )


#command FREEZE <n> [BROWSE] COLUMNS [OF <(tb)>];
=>;
         BrowseObject( <(tb)> ):freeze:= <n>

// TBrowse specific SETs
#command SET BROWSE HEADING SEPARATOR [OF <(tb)>] TO <hSep>;
=>;
         BrowseObject( <(tb)> ):headSep:= <hSep>

#command SET BROWSE FOOTING SEPARATOR [OF <(tb)>] TO <fSep>;
=>;
         BrowseObject( <(tb)> ):footSep:= <fSep>

#command SET BROWSE COLUMN SEPARATOR [OF <(tb)>] TO <cSep>;
=>;
         BrowseObject( <(tb)> ):colSep:= <cSep>

#command SET BROWSE COLORS [OF <(tb)>] TO <*colorSpec*>;
=>;
         BrowseObject( <(tb)> ):colorSpec:= #<colorSpec>


// TBColumn specific SETs
#command SET COLUMN WIDTH [OF <(c)>] [BROWSE <(tb)>] TO <n>;
=>;
         ColumnObject( <(c)>,<(tb)> ):width:= <n>

#command SET COLUMN COLORS [OF <(c)>] [BROWSE <(tb)>] TO <x>,<y>;
=>;
         ColumnObject( <(c)>,<(tb)> ):defColor:= { <x>,<y> }

#command SET COLUMN COLORS [OF <(c)>] [BROWSE <(tb)>] USING <expr>;
=>;
         ColumnObject( <(c)>,<(tb)> ):colorBlock:= {|| <expr> }

#command SET COLUMN HEADING [OF <(c)>] [BROWSE <(tb)>] TO <head>;
=>;
         ColumnObject( <(c)>,<(tb)> ):heading:= <head>

#command SET COLUMN FOOTING [OF <(c)>] [BROWSE <(tb)>] TO <foot>;
=>;
         ColumnObject( <(c)>,<(tb)> ):footing:= <foot>

#command SET COLUMN HEADING SEPARATOR [OF <(c)>] [BROWSE <(tb)>] TO <hSep>;
=>;
         ColumnObject( <(c)>,<(tb)> ):headSep:= <hSep>

#command SET COLUMN FOOTING SEPARATOR [OF <(c)>] [BROWSE <(tb)>] TO <fSep>;
=>;
         ColumnObject( <(c)>,<(tb)> ):footSep:= <fSep>

#command SET COLUMN SEPARATOR [OF <(c)>] [BROWSE <(tb)>] TO <cSep>;
=>;
         ColumnObject( <(c)>,<(tb)> ):colSep:= <cSep>

// EOF





